function genarate_network( handles )
%GENARATE_NETWORK Summary of this function goes here
%   Detailed explanation goes here
global cells;
global users;
global r;
global isd;
global averegedistance;
global totaltime;
global maxMacroPower;
global maxFemtoPower;
global fixedPower;
global femto_dist;
global steps_number;

h = waitbar(0,'Generating Macro Cells. Please wait...');
nr=str2num(get(handles.edit_nr, 'String'));
nc=str2num(get(handles.edit_nc, 'String'));
nf=str2num(get(handles.edit_femto_cells, 'String'));
n_macro_users=str2num(get(handles.edit_macro_users, 'String'));
n_femto_users=str2num(get(handles.edit_femto_users, 'String'));
fixedPower=str2num(get(handles.edit_power, 'String'));
cells=[];
[centerX,centerY]=meshgrid(1:nc,1:nr);
centerX=isd*centerX;
centerX(2:2:end,:)=isd/2+centerX(2:2:end,:);
centerY=centerY*isd*sqrt(0.75);
for i=1:nr
    for j=1:nc
        cells((i-1)*nc+j).type='macro';
        cells((i-1)*nc+j).x=centerX(i,j);
        cells((i-1)*nc+j).y=centerY(i,j);
        cells((i-1)*nc+j).color='blue';
        cells((i-1)*nc+j).power=maxMacroPower;
    end
end
% nr*nc+nf
% length(cells)
% n_macro_users+n_femto_users
% length(users)
% if (((nr*nc+nf)~=length(cells))||((n_macro_users+n_femto_users)~=length(users)))
users=[];
maxX=max(cell2mat({cells(:).x}));
maxY=max(cell2mat({cells(:).y}));
minX=min(cell2mat({cells(:).x}));
minY=min(cell2mat({cells(:).y}));
maxdist=r;
% generate femto cells
waitbar(0.3,h,'Generating Users. Please wait...');
for femto=1:nf
    cells(nr*nc+femto).type='femto';
    cells(nr*nc+femto).in_macro=-1;
    cells(nr*nc+femto).power=maxFemtoPower;
    while(cells(nr*nc+femto).in_macro<0)
        % Lines: 54-55 refer to the [x,y] position of femto cells inside macro cells 
        cells(nr*nc+femto).x=rand()*(maxX-minX+2*isd*sqrt(0.75));
        cells(nr*nc+femto).y=rand()*(maxY-minY+2*isd*sqrt(0.75));
        for macro=1:nc*nr
            dist=sqrt((cells(macro).x-cells(nr*nc+femto).x)^2+(cells(macro).y-cells(nr*nc+femto).y)^2);
            if (dist<=maxdist)
                cells(nr*nc+femto).in_macro=macro;
            end
        end;
    end
    temp=cells(nr*nc+femto).in_macro;
    if (mod(temp,nc)==0)
        if (temp>(nr-1)*nc)
            if (mod(ceil(temp/nc),2)==0)
                cells(nr*nc+femto).neighbors=[temp-1,temp,temp-nc];
            else
                cells(nr*nc+femto).neighbors=[temp-1,temp,temp-nc,temp-nc-1];
            end
        elseif (temp<=nc)
            cells(nr*nc+femto).neighbors=[temp-1,temp,temp+nc,temp+nc-1];
        else
            if (mod(ceil(temp/nc),2)==0)
                cells(nr*nc+femto).neighbors=[temp-1,temp,temp+nc,temp-nc];
            else
                cells(nr*nc+femto).neighbors=[temp-1,temp,temp+nc,temp+nc-1,temp-nc,temp-nc-1];
            end
        end
    elseif (mod(temp,nc)==1)
        if (temp>(nr-1)*nc)
            if (mod(ceil(temp/nc),2)==0)
                cells(nr*nc+femto).neighbors=[temp,temp+1,temp-nc,temp-nc+1];
            else
                cells(nr*nc+femto).neighbors=[temp,temp+1,temp-nc];
            end
        elseif (temp<=nc)
            cells(nr*nc+femto).neighbors=[temp,temp+1,temp+nc];
        else
            if (mod(ceil(temp/nc),2)==0)
                cells(nr*nc+femto).neighbors=[temp,temp+1,temp+nc,temp+nc+1,temp-nc,temp-nc+1];
            else
                cells(nr*nc+femto).neighbors=[temp,temp+1,temp+nc,temp-nc];
            end
        end
    else
        if (temp>(nr-1)*nc)
            if (mod(ceil(temp/nc),2)==0)
                cells(nr*nc+femto).neighbors=[temp-1,temp,temp+1,temp-nc,temp-nc+1];
            else
                cells(nr*nc+femto).neighbors=[temp-1,temp,temp+1,temp-nc,temp-nc-1];
            end
        elseif (temp<=nc)
            cells(nr*nc+femto).neighbors=[temp-1,temp,temp+1,temp+nc,temp+nc-1];
        else
            if (mod(ceil(temp/nc),2)==0)
                cells(nr*nc+femto).neighbors=[temp-1,temp,temp+1,temp+nc,temp+nc+1,temp-nc,temp-nc+1];
            else
                cells(nr*nc+femto).neighbors=[temp-1,temp,temp+1,temp+nc,temp+nc-1,temp-nc,temp-nc-1];
            end
        end
    end
    %cells(nr*nc+femto).neighbors=[cells(nr*nc+femto).in_macro,cells(nr*nc+femto).in_macro-1,cells(nr*nc+femto).in_macro+1,,,,,,]
    cells(nr*nc+femto).color='green';
end

i=1;
waitbar(0.5,h,'Generating Users. Please wait...');
averegedistance=0;
while(i<=n_macro_users)
    % Lines: 122-123 refer to the [x,y] position of macro users inside macro cells
    temp_x=rand()*(maxX-minX+2*isd*sqrt(0.75));
    temp_y=rand()*(maxY-minY+2*isd*sqrt(0.75));
    for j=1:length(cells)
        dist=sqrt((cells(j).x-temp_x)^2+(cells(j).y-temp_y)^2);
        if ((dist<=maxdist)&&strcmp(cells(j).type,'macro'))
            users(i).startx=temp_x;
            users(i).starty=temp_y;
            users(i).x=temp_x;
            users(i).y=temp_y;
            users(i).base=j;
            users(i).dist=dist;
            users(i).type='macro';
            if (rand()>0.5)
                users(i).finx=users(i).x+rand()*(isd/2-abs(cells(j).x-temp_x));
            else
                users(i).finx=users(i).x-rand()*(isd/2-abs(cells(j).x-temp_x));
            end
            if (rand()>0.5)
                users(i).finy=users(i).y+rand()*(isd/2-abs(cells(j).y-temp_y));
            else
                users(i).finy=users(i).y-rand()*(isd/2-abs(cells(j).y-temp_y));
            end
            while(sqrt((cells(j).x-users(i).finx)^2+(cells(j).y-users(i).finy)^2)>maxdist)
                if (rand()>0.5)
                    users(i).finx=users(i).x+rand()*(isd/2-abs(cells(j).x-temp_x));
                else
                    users(i).finx=users(i).x-rand()*(isd/2-abs(cells(j).x-temp_x));
                end
                if (rand()>0.5)
                    users(i).finy=users(i).y+rand()*(isd/2-abs(cells(j).y-temp_y));
                else
                    users(i).finy=users(i).y-rand()*(isd/2-abs(cells(j).y-temp_y));
                end
            end
            averegedistance=averegedistance+sqrt((users(i).finx-users(i).startx)^2+(users(i).finy-users(i).starty)^2)/n_macro_users;
            i=i+1;
            break;
        end
    end
end

[totalmeanbitrate,maxfps] = tracefile_input();
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for index=n_macro_users:n_macro_users+n_femto_users
    if (index<=round(length(n_macro_users:n_macro_users+n_femto_users)*(1/3)))
        temprate(index)=totalmeanbitrate(1,1)/maxfps(1,1);
    elseif (index>=round(length(n_macro_users:n_macro_users+n_femto_users)*(1/3)) && index<=round(length(n_macro_users:n_macro_users+n_femto_users)*(2/3)))
        temprate(index)=totalmeanbitrate(1,2)/maxfps(1,2);
    else
        temprate(index)=totalmeanbitrate(1,3)/maxfps(1,3);
    end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for femto_user=n_macro_users:n_macro_users+n_femto_users
users(femto_user).base=nr*nc+ceil(rand()*nf);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Lines: 164-167 refer to the [x,y] position of femto users inside femto cells
% temp_x=randn()*r*0.05+cells(users(femto_user).base).x;
% temp_y=randn()*r*0.05+cells(users(femto_user).base).y;
switch femto_dist
 case 'border'
     % Near Femto border (above 80% of femto Radius)
     r_min = 0.80;
     r_max = 1.00;
     temp_x=abs((r_max-r_min).*rand(1,1) + r_min)*r*0.05+cells(users(femto_user).base).x;
     temp_y=abs((r_max-r_min).*rand(1,1) + r_min)*r*0.05+cells(users(femto_user).base).y;
 case 'center'
     % Near Femto center (below 50% of femto Radius)
     r_min = 0.00;
     r_max = 0.50;
     temp_x=abs((r_max-r_min).*rand(1,1) + r_min)*r*0.05+cells(users(femto_user).base).x;
     temp_y=abs((r_max-r_min).*rand(1,1) + r_min)*r*0.05+cells(users(femto_user).base).y;
 case 'random'
     temp_x=randn()*r*0.05+cells(users(femto_user).base).x;
     temp_y=randn()*r*0.05+cells(users(femto_user).base).y;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
users(femto_user).startx=temp_x;
users(femto_user).starty=temp_y;
users(femto_user).x=temp_x;
users(femto_user).y=temp_y;
users(femto_user).finx=temp_x;
users(femto_user).finy=temp_y;
users(femto_user).dist=sqrt((temp_x-cells(users(femto_user).base).x)^2+(temp_y-cells(users(femto_user).base).y)^2);
users(femto_user).type='femto';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
users(femto_user).load=temprate(femto_user);
end
totaltime=(averegedistance/3000)*60*60;
for j=1:length(cells)
   cells(j).numberofusers=0; 
end
for j=1:length(users)
    cells(users(j).base).numberofusers=cells(users(j).base).numberofusers+1;
end
% end
close(h)
end

