function [total_metric,metric,th,cells] = performance_calc(cells,handles)
global r;
global resource_block;
global users;
global user;
global max_resource_per_user;
global alpha;
global bitsPerSymbol;
global requiredRSRP;
global maxMacroPower;
global minMacroPower;
global maxFemtoPower;
global minFemtoPower;
global target_throughput;
global parameter_a;
global parameter_b;
global P_offset_o;
global parameter_g;
global parameter_k;
global antenna_gain;
global steps_number;
global Low;
global fixedPower;
global femto_dist;
global MCS;
global RBCount;
global QoS_Enabled;
global totaltime;

% P(dBm) = 10*log10(1000*P)
% P(W) = (10^(P/10))/1000

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
step_window_size = 1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

total_metric=0;
metric=0;
th=0;

[totalmeanbitrate,maxfps] = tracefile_input();

for step=1:steps_number
    
    %initialize
    for i=1:length(cells)
        if strcmp(cells(i).type,'macro')
            cells(i).power(step,1)=maxMacroPower;
        else
            cells(i).power(step,1)=maxFemtoPower;
        end
        cells(i).subcarrier_power(step,1)=10*log10(10^(cells(i).power(step,1)/10)/(resource_block*12000)*1000);
        cells(i).throughput(step,1)=0;
        cells(i).throughput(step,2)=0;
        cells(i).throughput(step,3)=0;
        cells(i).throughput(step,4)=0;
    end
    
    
    for i=1:length(cells)
        if strcmp(cells(i).type,'femto')
            
%     %algorithm1
            cells(i).power(step,1)=fixedPower;
            cells(i).subcarrier_power(step,1)=10*log10(10^(cells(i).power(step,1)/10)/(resource_block*12000)*1000);
            
            
            
%             temp_min_rsrp=inf;
%             for z=1:length(users)
%                 if (users(z).base==i)
%                     temp_dist=sqrt((cells(i).x-users(z).x)^2+(cells(i).y-users(z).y)^2);
%                     temp_rsrp=cells(i).subcarrier_power(step,1)+antenna_gain-pathloss_femto_indoor(temp_dist);
%                     if (temp_min_rsrp>temp_rsrp)
%                         temp_min_rsrp=temp_rsrp;
%                     end
%                 end
%             end
%             while ((temp_min_rsrp<(1.2*requiredRSRP))||(temp_min_rsrp>(0.8*requiredRSRP)))
%                 if (temp_min_rsrp>(0.8*requiredRSRP))
%                     cells(i).power(step,1)=cells(i).power(step,1)-1;
%                     if (cells(i).power(step,1)<minFemtoPower)
%                         cells(i).power(step,1)=minFemtoPower;
%                         break;
%                     end
%                 elseif (temp_min_rsrp<(1.2*requiredRSRP))
%                     cells(i).power(step,1)=cells(i).power(step,1)+1;
%                     if (cells(i).power(step,1)>maxFemtoPower)
%                         cells(i).power(step,1)=maxFemtoPower;
%                         break;
%                     end
%                 end
%                 cells(i).subcarrier_power(step,1)=10*log10(10^(cells(i).power(step,1)/10)/(resource_block*12000)*1000);
%                 temp_min_rsrp=inf;
%                 for z=1:length(users)
%                     if (users(z).base==i)
%                         temp_dist=sqrt((cells(i).x-users(z).x)^2+(cells(i).y-users(z).y)^2);
%                         temp_rsrp=cells(i).subcarrier_power(step,1)+antenna_gain-pathloss_femto_indoor(temp_dist);
%                         if (temp_min_rsrp>temp_rsrp)
%                             temp_min_rsrp=temp_rsrp;
%                         end
%                     end
%                 end
%             end
            
    %algorithm2
            %CRS=zeros(length(cells),1); den prepei na to kanw
            for j=1:length(cells)
                if ((i~=j) && strcmp(cells(j).type,'macro'))
                    CRS(j)=cells(j).subcarrier_power(step)+antenna_gain-pathloss_macro_indoor(sqrt((cells(i).x-cells(j).x)^2+(cells(i).x-cells(j).x)^2));
                    CRS(j)=10*log10(((10^(CRS(j)/10)/1000)*1000)*12);
                    %10*log10((10^(cells(j).subcarrier_power(step)/10)/1000)*12000)
                end
            end
            temp_pathloss=zeros(length(users),1);
            for j=1:length(users)
                if (users(j).base==i)
                    temp_pathloss(j)=pathloss_femto_indoor(sqrt((cells(i).x-users(j).x)^2+(cells(i).y-users(j).y)^2));
                end
            end
%             max(CRS)+max(temp_pathloss)-parameter_g
            cells(i).power(step,2)=max(minFemtoPower,min(maxFemtoPower,max(CRS)+max(temp_pathloss)-parameter_g));
%             cells(i).power(step,2)=max(min(parameter_a*(max(CRS)+10*log10(resource_block*12))+parameter_b,maxFemtoPower),minFemtoPower);
%             parameter_a*(max(CRS)+10*log10(resource_block*12))+parameter_b
            cells(i).subcarrier_power(step,2)=10*log10(10^(cells(i).power(step,2)/10)/(resource_block*12000)*1000);
            
    %algorithm3
            macro_femto_rsrp=cells(cells(i).in_macro).subcarrier_power(step)+antenna_gain-pathloss_macro_indoor(sqrt((cells(i).x-cells(cells(i).in_macro).x)^2+(cells(i).y-cells(cells(i).in_macro).y)^2));
            P_offset=mean([P_offset_o+parameter_k*Low,50+Low,100+Low]);
            cells(i).subcarrier_power(step,3)=mean([macro_femto_rsrp+P_offset,10*log10((10^(maxFemtoPower/10))/(resource_block*12)),10*log10((10^(minFemtoPower/10))/(resource_block*12))]);
            cells(i).power(step,3)=10*log10(10^(cells(i).subcarrier_power(step,3)/10)*(resource_block*12));
        else
%power calc for macro cells

%             temp_min_rsrp=inf;
%             for z=1:length(users)
%                 if (users(z).base==i)
%                     temp_dist=sqrt((cells(i).x-users(z).x)^2+(cells(i).y-users(z).y)^2);
%                     temp_rsrp=cells(i).subcarrier_power(step,1)+antenna_gain-pathloss_macro_outdoor(temp_dist);
%                     if (temp_min_rsrp>temp_rsrp)
%                         temp_min_rsrp=temp_rsrp;
%                     end
%                 end
%             end
%             while ((temp_min_rsrp<(1.2*requiredRSRP))||(temp_min_rsrp>(0.8*requiredRSRP)))
%                 if (temp_min_rsrp>(0.8*requiredRSRP))
%                     cells(i).power(step,1)=cells(i).power(step,1)-1;
%                     if (cells(i).power(step,1)<minMacroPower)
%                         cells(i).power(step,1)=minMacroPower;
%                         break;
%                     end
%                 elseif (temp_min_rsrp<(1.2*requiredRSRP))
%                     cells(i).power(step,1)=cells(i).power(step,1)+1;
%                     if (cells(i).power(step,1)>maxMacroPower)
%                         cells(i).power(step,1)=maxMacroPower;
%                         break;
%                     end
%                 end
%                 cells(i).subcarrier_power(step,1)=10*log10(10^(cells(i).power(step,1)/10)/(resource_block*12000));
%                 temp_min_rsrp=inf;
%                 for z=1:length(users)
%                     if (users(z).base==i)
%                         temp_dist=sqrt((cells(i).x-users(z).x)^2+(cells(i).y-users(z).y)^2);
%                         temp_rsrp=cells(i).subcarrier_power(step,1)+antenna_gain-pathloss_macro_outdoor(temp_dist);
%                         if (temp_min_rsrp>temp_rsrp)
%                             temp_min_rsrp=temp_rsrp;
%                         end
%                     end
%                 end
%             end
%             cells(i).power(step,1)
        end
    end
    
%measurement user rsrp
    for j=1:length(users)
        [users(j).pathloss(step,1),users(j).sinr(step,1)]=sinr_calc(cells,users(j),step,1);
        users(j).rsrp(step,1)=cells(users(j).base).subcarrier_power(step,1)+antenna_gain-users(j).pathloss(step,1);
        %%%%%%%%%%%%Per User Throughput Calculation here!!!%%%%%%%%%%%%
        users(j).throughput(step,1)=min([resource_block*12*cells(users(j).base).numberofusers(step),(max_resource_per_user*12)])*15000*bitsPerSymbol*log2(1+alpha*users(j).sinr(step,1));
        cells(users(j).base).throughput(step,1)=cells(users(j).base).throughput(step,1)+users(j).throughput(step,1);
    end
    for j=1:length(users)
        [users(j).pathloss(step,2),users(j).sinr(step,2)]=sinr_calc(cells,users(j),step,2);
        if strcmp(cells(users(j).base).type,'femto')
            users(j).rsrp(step,2)=cells(users(j).base).subcarrier_power(step,2)+antenna_gain-users(j).pathloss(step,2);
        else
            users(j).rsrp(step,2)=cells(users(j).base).subcarrier_power(step,1)+antenna_gain-users(j).pathloss(step,2);
        end
        users(j).throughput(step,2)=min([resource_block*12*cells(users(j).base).numberofusers(step),(max_resource_per_user*12)])*15000*bitsPerSymbol*log2(1+alpha*users(j).sinr(step,2));
        cells(users(j).base).throughput(step,2)=cells(users(j).base).throughput(step,2)+users(j).throughput(step,2);
    end
    for j=1:length(users)
        [users(j).pathloss(step,3),users(j).sinr(step,3)]=sinr_calc(cells,users(j),step,3);
        if strcmp(cells(users(j).base).type,'femto')
            users(j).rsrp(step,3)=cells(users(j).base).subcarrier_power(step,3)+antenna_gain-users(j).pathloss(step,3);
        else
            users(j).rsrp(step,3)=cells(users(j).base).subcarrier_power(step,1)+antenna_gain-users(j).pathloss(step,3);
        end
        users(j).throughput(step,3)=min([resource_block*12*cells(users(j).base).numberofusers(step),(max_resource_per_user*12)])*15000*bitsPerSymbol*log2(1+alpha*users(j).sinr(step,3));
        cells(users(j).base).throughput(step,3)=cells(users(j).base).throughput(step,3)+users(j).throughput(step,3);
    end
    
    
    
%proposed
    for i=1:length(cells)
        if strcmp(cells(i).type,'femto')
            temp=find(cells(i).power(step,1:3)==min(cells(i).power(step,1:3)),1);% find min power
            group_population=zeros(3,1);
            group_throughput=zeros(3,1);
            cells(i).alg_selection(step,:)=[temp,temp,temp];
            for j=1:length(users)
                if (users(j).base==i)
                    if (users(j).load>=2/3)
                        users(j).group=1;
                        group_population(1)=group_population(1)+1;
                        users(j).rsrp(step,4)=users(j).rsrp(step,cells(i).alg_selection(step,users(j).group));
                        users(j).throughput(step,4)=users(j).throughput(step,cells(i).alg_selection(step,users(j).group));
                        group_throughput(1)=group_throughput(1)+users(j).throughput(step,4);
                    elseif (users(j).load>=1/3)
                        users(j).group=2;
                        group_population(2)=group_population(2)+1;
                        users(j).rsrp(step,4)=users(j).rsrp(step,cells(i).alg_selection(step,users(j).group));
                        users(j).throughput(step,4)=users(j).throughput(step,cells(i).alg_selection(step,users(j).group));
                        group_throughput(2)=group_throughput(2)+users(j).throughput(step,4);
                    else
                        users(j).group=3;
                        group_population(3)=group_population(3)+1;
                        users(j).rsrp(step,4)=users(j).rsrp(step,cells(i).alg_selection(step,users(j).group));
                        users(j).throughput(step,4)=users(j).throughput(step,cells(i).alg_selection(step,users(j).group));
                        group_throughput(3)=group_throughput(3)+users(j).throughput(step,4);
                    end
                end
            end
            cells(i).group_population(step,:)=group_population;
            group_throughput=group_throughput./group_population;
            
            while (group_throughput(1)<target_throughput(1))
%               temp=max(find(sort(cells(i).power(step,1:3))==cells(i).power(step,cells(i).alg_selection(step,1))))+1;
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                temp1=max(find(sort(cells(i).power(step,1:length(cells(i).power(step,:))))==cells(i).power(step,cells(i).alg_selection(step,1))))+1;          
                if (temp1 > length(cells(i).power(step,:)))
                      temp1 = temp1 - 1;
%                     cells(i).power = [cells(i).power(step,:) 4];
                end;
                alg_select_temp1(step) = find(cells(i).power(step,1:length(cells(i).power(step,:)))==cells(i).power(step,temp1),1);  
                if (step >= step_window_size)
                    alg_selection_median1 = round(median(alg_select_temp1(((step-step_window_size) + 1):step)));
                    cells(i).alg_selection(((step-step_window_size) + 1):step,1)=alg_selection_median1;
                else
                    cells(i).alg_selection(step,1)=alg_select_temp1(step);
                end;
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                group_throughput(1)=0;
                for j=1:length(users)
                    if (users(j).base==i)&&(users(j).group==1)
                        users(j).rsrp(step,4)=users(j).rsrp(step,cells(i).alg_selection(step,users(j).group));
                        users(j).throughput(step,4)=users(j).throughput(step,cells(i).alg_selection(step,users(j).group));
                        group_throughput(1)=group_throughput(1)+users(j).throughput(step,4);
                    end
                end
                if temp1==3
                    break;
                end
            end
            while (group_throughput(2)<target_throughput(2))
%                 temp=max(find(sort(cells(i).power(step,1:3))==cells(i).power(step,cells(i).alg_selection(step,2))))+1;
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                temp2=max(find(sort(cells(i).power(step,1:length(cells(i).power(step,:))))==cells(i).power(step,cells(i).alg_selection(step,2))))+1;           
                if (temp2 > length(cells(i).power(step,:)))
                    temp2 = temp2 - 1;
%                     cells(i).power = [cells(i).power(step,:) 4];
                end;
                alg_select_temp2(step) = find(cells(i).power(step,1:length(cells(i).power(step,:)))==cells(i).power(step,temp2),1);        
                if (step >= step_window_size)
                    alg_selection_median2 = round(median(alg_select_temp2(((step-step_window_size) + 1):step)));
                    cells(i).alg_selection(((step-step_window_size) + 1):step,2)=alg_selection_median2;
                else
                    cells(i).alg_selection(step,2)=alg_select_temp2(step);
                end;
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                group_throughput(2)=0;
                for j=1:length(users)
                    if (users(j).base==i)&&(users(j).group==2)
                        users(j).rsrp(step,4)=users(j).rsrp(step,cells(i).alg_selection(step,users(j).group));
                        users(j).throughput(step,4)=users(j).throughput(step,cells(i).alg_selection(step,users(j).group));
                        group_throughput(2)=group_throughput(2)+users(j).throughput(step,4);
                    end
                end
                if temp2==3
                    break;
                end
                
            end
            while (group_throughput(3)<target_throughput(3))
%                 temp=max(find(sort(cells(i).power(step,1:3))==cells(i).power(step,cells(i).alg_selection(step,3))))+1;
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 temp3=max(find(sort(cells(i).power(step,1:length(cells(i).power(step,:))))==cells(i).power(step,cells(i).alg_selection(step,3))))+1;             
                 if (temp3 > length(cells(i).power(step,:)))
                     temp3 = temp3 - 1;
%                      cells(i).power = [cells(i).power(step,:) 4];
                 end;
                alg_select_temp3(step) = find(cells(i).power(step,1:length(cells(i).power(step,:)))==cells(i).power(step,temp3),1);       
                if (step >= step_window_size)
                    alg_selection_median3 = round(median(alg_select_temp3(((step-step_window_size) + 1):step)));
                    cells(i).alg_selection(((step-step_window_size) + 1):step,3)=alg_selection_median3;
                else
                    cells(i).alg_selection(step,3)=alg_select_temp3(step);
                end;
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                group_throughput(3)=0;
                for j=1:length(users)
                    if (users(j).base==i)&&(users(j).group==3)
                        users(j).rsrp(step,4)=users(j).rsrp(step,cells(i).alg_selection(step,users(j).group));
                        users(j).throughput(step,4)=users(j).throughput(step,cells(i).alg_selection(step,users(j).group));
                        group_throughput(3)=group_throughput(3)+users(j).throughput(step,4);
                    end
                end
                if temp3==3
                    break;
                end
            end
            total_power=0;
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
             if (cells(i).alg_selection(step,1) > size(cells(i).subcarrier_power(step,:),2))
                 cells(i).subcarrier_power(step,end + 1) = cells(i).alg_selection(step,1);              
             end;
             if (cells(i).alg_selection(step,2) > size(cells(i).subcarrier_power(step,:),2))
                 cells(i).subcarrier_power(step,end + 1) = cells(i).alg_selection(step,2);              
             end;
             if (cells(i).alg_selection(step,3) > size(cells(i).subcarrier_power(step,:),2))
                 cells(i).subcarrier_power(step,end + 1) = cells(i).alg_selection(step,3);              
             end;
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            total_power=total_power+((group_population(1)/sum(group_population))*resource_block*12)*(10^(cells(i).subcarrier_power(step,cells(i).alg_selection(step,1))/10)/1000);
            total_power=total_power+((group_population(2)/sum(group_population))*resource_block*12)*(10^(cells(i).subcarrier_power(step,cells(i).alg_selection(step,2))/10)/1000);
            total_power=total_power+((group_population(3)/sum(group_population))*resource_block*12)*(10^(cells(i).subcarrier_power(step,cells(i).alg_selection(step,3))/10)/1000);
            total_power=10*log10(total_power*1000);
            cells(i).power(step,4)=total_power;
        end
    end
    
    for j=1:length(users)
        [users(j).pathloss(step,4),users(j).sinr(step,4)]=sinr_calc(cells,users(j),step,4);
        if strcmp(cells(users(j).base).type,'femto')
            if (users(j).load>=2/3)
                users(j).rsrp(step,4)=cells(users(j).base).subcarrier_power(step,cells(users(j).base).alg_selection(step,1))+antenna_gain-users(j).pathloss(step,4);
                users(j).throughput(step,4)=users(j).throughput(step,cells(users(j).base).alg_selection(step,1));
            elseif (users(j).load>=1/3)
                users(j).rsrp(step,4)=cells(users(j).base).subcarrier_power(step,cells(users(j).base).alg_selection(step,2))+antenna_gain-users(j).pathloss(step,4);
                users(j).throughput(step,4)=users(j).throughput(step,cells(users(j).base).alg_selection(step,2));
            else
                users(j).rsrp(step,4)=cells(users(j).base).subcarrier_power(step,cells(users(j).base).alg_selection(step,3))+antenna_gain-users(j).pathloss(step,4);
                users(j).throughput(step,4)=users(j).throughput(step,cells(users(j).base).alg_selection(step,3));
            end
        else
            users(j).rsrp(step,4)=cells(users(j).base).subcarrier_power(step,1)+antenna_gain-users(j).pathloss(step,4);
            users(j).throughput(step,4)=min([resource_block*12*cells(users(j).base).numberofusers(step),(max_resource_per_user*12)])*15000*bitsPerSymbol*log2(1+alpha*users(j).sinr(step,4));
        end
        cells(users(j).base).throughput(step,4)=cells(users(j).base).throughput(step,4)+users(j).throughput(step,4);
    end
    
                                                                              %%% Call QoS Traffic Scheduler Mechanism here %%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% From -HST Simulator- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    RBCount = 0;
    for i=1:length(cells)
        if strcmp(cells(i).type,'femto')
            for j=1:length(users)
                if strcmp(cells(users(j).base).type,'femto')
                    for k=1:length(target_throughput)                     
                        Uload=group_throughput(k);
                        user(users(j).base,step,i).uBuffer=Uload;
                        BTSload=cells(i).throughput(step,k);
                        user(users(j).base,step,i).BTSbuffer=BTSload;
                        
                        if strcmp(QoS_Enabled,'yes')
                            %%% Assign Resource Block
                            [~,users(j).sinr(step,k)]=sinr_calc(cells,users(j),step,k);
                            
                            if(users(j).sinr(step,k)>0)
                                if (users(j).sinr(step,k)>10)
                                    MCS=16;
                                elseif (users(j).sinr(step,k)>5)
                                    MCS=8;
                                else
                                    MCS=4;
                                end
                            else
                                MCS=2;
                            end

                            num=round(BTSload/MCS);

                            if(num>100)
                                %num=100;
                                num=round(100*abs(users(j).sinr(step,k)));
                            end

                            RBCount = num + 1;                            
                            resource_block = RBCount;

                            if(RBCount>=23900)
                                break;
                            end;

                            user(users(j).base,step,i).BTSbuffer=abs(BTSload-MCS*num);
                            
                            %%%Compute Throughput
                            users(users(j).base).throughput(step,4)=round(MCS*num); %%% Check Later!
                        end
                        %%%Compute Delay
                        user(users(j).base,step,i).delay(k) = 0;
                        if(user(users(j).base,step,i).uBuffer==0)
                            user(users(j).base,step,i).delay(k)=0;
                        elseif(user(users(j).base,step,i).BTSbuffer<user(users(j).base,step,i).uBuffer)
                            array=user(users(j).base,1:step,i).delay;
                            user(users(j).base,step,i).delay(k)=user(users(j).base,step,i).BTSbuffer/user(users(j).base,step,i).uBuffer + sum(array(k));
                        elseif(user(users(j).base,step,i).BTSbuffer>user(users(j).base,step,i).uBuffer)
                            array=user(users(j).base,1:step,i).delay;
                            user(users(j).base,step,i).delay(k)=user(users(j).base,step,i).uBuffer/user(users(j).base,step,i).BTSbuffer + sum(array(k));
                        end
                    end
                end
            end
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
%update user position
    for j=1:length(cells)
       cells(j).numberofusers(step+1)=0; 
    end
    for j=1:length(users)
        if strcmp(users(j).type,'macro')
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            if (j<=round(length(users)*(1/3)))
                temprate(j)=totalmeanbitrate(step,1)/maxfps(1,1);
            elseif (j>=round(length(users)*(1/3)) && j<=round(length(users)*(2/3)))
                temprate(j)=totalmeanbitrate(step,2);
            else
                temprate(j)=totalmeanbitrate(step,3)/maxfps(1,3);
            end;
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            users(j).x=users(j).startx+(step/10)*(users(j).finx-users(j).startx);
            users(j).y=users(j).starty+(step/10)*(users(j).finy-users(j).starty);
            for z=1:length(cells)
                dist=sqrt((cells(z).x-users(j).x)^2+(cells(z).y-users(j).y)^2);
                if ((dist<=0.08*r)&&strcmp(cells(z).type,'femto'))
                    users(j).dist=dist;
                    if strcmp(users(j).type,'macro')
                        users(j).type='femto';
                        users(j).base=z;
                        users(j).load=temprate(j);
                    end
                    break;
                elseif ((dist<=r)&&strcmp(cells(z).type,'macro'))
                    users(j).dist=dist;
                    users(j).type='macro';
                    users(j).base=z;
                end
            end
        end
        cells(users(j).base).numberofusers(step+1)=cells(users(j).base).numberofusers(step+1)+1;
    end
    
    if (step<steps_number)
        for j=1:length(cells)
            if strcmp(cells(j).type,'femto')
                n_users=length(users);
                if step>steps_number/2
                      extra_users=max(ceil(cells(j).numberofusers/10),10);
                else
                    extra_users=max(ceil(cells(j).numberofusers/20),2);
                end
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                for z=1:extra_users
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    if (z<=round(length(extra_users)*(1/3)))
                        temprate(n_users+z)=totalmeanbitrate(step,1)/maxfps(1,1);
                    elseif (z>=round(length(extra_users)*(1/3)) && z<=round(length(extra_users)*(2/3)))
                        temprate(n_users+z)=totalmeanbitrate(step,2);
                    else
                        temprate(n_users+z)=totalmeanbitrate(step,3)/maxfps(1,3);
                    end;
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    users(n_users+z).base=j;
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    % Lines: 370-381 refer to the [x,y] position of femto users inside femto cells
%                     temp_x=(randn()*r*0.05+cells(users(n_users+z).base).x);
%                     temp_y=randn()*r*0.05+cells(users(n_users+z).base).y;
                    switch femto_dist
                        case 'border'
                            % Near Femto border (above 80% of femto Radius)
                            r_min = 0.80;
                            r_max = 1.00;
                            temp_x=abs((r_max-r_min).*rand(1,1) + r_min)*r*0.05+cells(users(n_users+z).base).x;
                            temp_y=abs((r_max-r_min).*rand(1,1) + r_min)*r*0.05+cells(users(n_users+z).base).y;
                        case 'center'
                            % Near Femto center (below 50% of femto Radius)
                            r_min = 0.00;
                            r_max = 0.50;
                            temp_x=abs((r_max-r_min).*rand(1,1) + r_min)*r*0.05+cells(users(n_users+z).base).x;
                            temp_y=abs((r_max-r_min).*rand(1,1) + r_min)*r*0.05+cells(users(n_users+z).base).y;
                        case 'random'
                            temp_x=randn()*r*0.05+cells(users(n_users+z).base).x;
                            temp_y=randn()*r*0.05+cells(users(n_users+z).base).y;
                    end
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    users(n_users+z).startx=temp_x;
                    users(n_users+z).starty=temp_y;
                    users(n_users+z).x=temp_x;
                    users(n_users+z).y=temp_y;
                    users(n_users+z).finx=temp_x;
                    users(n_users+z).finy=temp_y;
                    users(n_users+z).dist=sqrt((temp_x-cells(users(n_users+z).base).x)^2+(temp_y-cells(users(n_users+z).base).y)^2);
                    users(n_users+z).type='femto';
                    users(n_users+z).load=temprate(n_users+z);
                    cells(users(n_users+z).base).numberofusers(step)=cells(users(n_users+z).base).numberofusers(step)+1;
                end
            end
        end
    end
end

function [pathloss,sinr]=sinr_calc(cells,user,step,alg)
global WGNVariance;

denominator=WGNVariance;
if strcmp(user.type,'macro')
    for i=1:length(cells)
        dist=sqrt((cells(i).x-user.x)^2+(cells(i).y-user.y)^2);
        if (i~=user.base)
            if strcmp(cells(i).type,'macro')
                denominator=denominator+(10^(-pathloss_macro_outdoor(dist)/10))*cells(i).power(step);
            else
                denominator=denominator+(10^(-pathloss_femto_outdoor(dist)/10))*cells(i).power(step,alg);
            end
        end
    end
    pathloss=pathloss_macro_outdoor(user.dist);
    sinr=(10^(-pathloss_macro_outdoor(user.dist)/10))*cells(user.base).power(step)/denominator;
else
    for i=1:length(cells)
        dist=sqrt((cells(i).x-user.x)^2+(cells(i).y-user.y)^2);
        if (i~=user.base)
            if strcmp(cells(i).type,'macro')
                denominator=denominator+(10^(-pathloss_macro_indoor(dist)/10))*cells(i).power(step);
            else
                denominator=denominator+(10^(-pathloss_femto_outdoor(dist)/10))*cells(i).power(step,alg);
            end
        end
    end
    pathloss=pathloss_femto_indoor(user.dist);
    sinr=(10^(-pathloss_femto_indoor(user.dist)/10))*cells(user.base).power(step,alg)/denominator;
end

% simplified pathloss
function pl=pathloss_macro_outdoor(d)
pl=128.15+37.6*log10(d/1000); %test from doc
%pl=15.3+37.6*log10(d);
function pl=pathloss_macro_indoor(d)
global Low;
pl=128.15+37.6*log10(d/1000)+Low+7; %test from doc
%pl=15.3+37.6*log10(d)+Low;
function pl=pathloss_femto_indoor(d)
pl=38.02+30*log10(d); %test from doc
%pl=38.46+20*log10(d);
function pl=pathloss_femto_outdoor(d)
global Low;
pl=38.02+30*log10(d)+Low; %test from doc
%pl=38.46+20*log10(d)+Low;
