function plot_network_new(cells,users)

global r;
fig=figure('Name','Topology','NumberTitle','off');
for i=1:length(cells)
    if (strcmp(cells(i).type,'macro')==1)
        [vertexX vertexY]=generate_cells_vertices(cells(i).x,cells(i).y);
        if (strcmp(cells(i).color,'red')==1)
            fill(vertexX,vertexY,'r');
        elseif (strcmp(cells(i).color,'green')==1)
            fill(vertexX,vertexY,'g');
        else
            fill(vertexX,vertexY,[0,0.65,0]);
        end
        if i==1
            hold on;
        end
    elseif (strcmp(cells(i).type,'femto')==1)
        filledCircle([cells(i).x,cells(i).y],0.08*r,10,[0,0.20,0]);
        text(cells(i).x+0.18*r,cells(i).y+0.18*r,num2str(i),'FontSize',25,'Color','k');
    end
end
for i=1:length(users)
    if (strcmp(users(i).type,'macro')==1)
        filledCircle([users(i).x,users(i).y],r/35,10,'w');
        line([users(i).startx ,users(i).finx],[users(i).starty ,users(i).finy],'Color','white','LineStyle',':');
    else
        filledCircle([users(i).x,users(i).y],r/35,10,'y');
    end
end
hold off;
axis equal;
axis off

saveas(fig,'Topology.fig');
print(fig,'-dpng','-r300','Topology.png');

function [vertexX,vertexY]=generate_cells_vertices(centerX,centerY)
global r;
v=30:60:390;
cv=r*cosd(v);
sv=r*sind(v);
vertexX=centerX+cv;
vertexY=centerY+sv;